package com.unitesk.requality_git.comm;

import java.util.Iterator;
import java.util.List;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.core.resources.IProject;
import org.eclipse.jface.dialogs.InputDialog;
import com.unitesk.requality.core.AttributesRulesHolder;
import com.unitesk.requality.core.AttributesVersioningRule;
import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.attribute.Attribute;
import com.unitesk.requality.core.attribute.AttributeDefinition;
import com.unitesk.requality.core.attribute.AttributeType;
import com.unitesk.requality.core.attribute.valueproviders.ConstValueProvider;
import com.unitesk.requality.eclipse.core.EclipseTracker;
import com.unitesk.requality.eclipse.ui.cnf.RequalityCNF;
import com.unitesk.requality.tools.DeepFirstTreeWalker;

public class GitPush extends AbstractHandler implements IHandler {

  @Override
  public Object execute(ExecutionEvent event) throws ExecutionException {
    List<Object> sel = RequalityCNF.getSelectedObj();
    InputDialog id;
    if (sel != null && sel.size() > 0) {
      Object o = sel.iterator().next();
      final JFrame parent = new JFrame();
      String name = JOptionPane.showInputDialog(parent, "Commit message", null);
      if (name == null) return null;
      GitManipulator gm;
      try {
        initVersions(EclipseTracker.getTracker().getTree(((IProject) o)));
        gm = new GitManipulator(((IProject) o));
        gm.setCurrentRevision("HEAD");
        gm.push(name);
        gm.close();
      } catch (Exception e) {
      }
    }

    // TODO Auto-generated method stub
    return null;
  }

  public static void initVersions(TreeDB db) {
    AttributesRulesHolder vrg = db.getAttributeRules();
    if(vrg.isVersioningEnabled()){
      DeepFirstTreeWalker dftw = new DeepFirstTreeWalker(db.getRootNode(),false,false,true);
      Iterator<TreeNode> it = dftw.iterator();
      while(it.hasNext()){
        TreeNode node = it.next();
        String s = "1";
        boolean ch = false;
        s = node.getNodeVersion();
        if(s.endsWith("*")){
          s = s.substring(0, s.length()-1);//changed
          ch = true;
        }
        if(ch){
          AttributeDefinition ad = new AttributeDefinition(node.getUUId(), 
              AttributesVersioningRule.ATTR_NODE_VERSION, 
              new ConstValueProvider(AttributeType.STRING, s));
          node.attrs().setAttribute(new Attribute(ad, node.attrs()));
          node.attrs().getChanged().addSomeChange(AttributesVersioningRule.ATTR_NODE_VERSION,
              null, ad);
          node.commitAttributes();
        }
      }
    }
  }

  @Override
  public boolean isEnabled() {
    List<Object> sel = RequalityCNF.getSelectedObj();
    if (sel != null && sel.size() > 0) {
      Object o = sel.iterator().next();
      IProject proj = ((IProject) o);
      GitManipulator gm;
      try {
        gm = new GitManipulator(proj);
        return true;
      } catch (Exception e) {
      }
    }
    return false;
  }
}
