package com.unitesk.requality_git.comm;

import java.util.List;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.ui.IEditorReference;
import org.eclipse.ui.PlatformUI;

import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.eclipse.core.EclipseTracker;
import com.unitesk.requality.eclipse.editors.browser.ReqMarker;
import com.unitesk.requality.eclipse.ui.cnf.RequalityCNF;
import com.unitesk.requality.eclipse.ui.editors.JSEditor;

public class GitReset extends AbstractHandler implements IHandler {

  @Override
  public Object execute(ExecutionEvent event) throws ExecutionException {
    List<Object> sel = RequalityCNF.getSelectedObj();
    if (sel != null && sel.size() > 0) {
      Object o = sel.iterator().next();
      GitManipulator gm;
      try {
        IProject proj = ((IProject) o);
        proj.refreshLocal(IResource.DEPTH_INFINITE, null);
        TreeDB db = EclipseTracker.getTracker().getTree(proj);
        db.clearAllCaches(false);
        proj.refreshLocal(IResource.DEPTH_INFINITE, null);
        gm = new GitManipulator(proj);
        closeEditors(proj);
        db.clearAllCaches(false);
        gm.setCurrentRevision("HEAD");
        gm.reset();
        gm.close();
        proj.refreshLocal(IResource.DEPTH_INFINITE, null);
        proj.close(null);
        proj.open(null);
        db = EclipseTracker.getTracker().getTree(proj);
        //db.getLinkResolver().getAllRevertLinks();
      } catch (Exception e) {
        // TODO Auto-generated catch block
        e.printStackTrace();
      }
    }
    // TODO Auto-generated method stub
    return null;
  }

  public static void closeEditors(IProject p2) {
    IEditorReference[] eRefs =
        PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getEditorReferences();
    for (IEditorReference eRef : eRefs) {
      if ((eRef.getEditor(false) instanceof JSEditor)) {
        JSEditor j = (JSEditor) eRef.getEditor(false);
        TreeDB db = (j).getRootNode().getTreeDB();
        IProject p = EclipseTracker.getTracker().getProject(db);
        if (p.equals(p2)) j.getSite().getPage().closeEditor(j, false);
      }
      if ((eRef.getEditor(false) instanceof ReqMarker)) {
        ReqMarker m = (ReqMarker) eRef.getEditor(false);
        TreeDB db = m.getRootNode().getTreeDB();
        IProject p = EclipseTracker.getTracker().getProject(db);
        if (p.equals(p2)) {
          m.getSite().getPage().closeEditor(m, false);
        }
      }
    }
  }

  @Override
  public boolean isEnabled() {
    List<Object> sel = RequalityCNF.getSelectedObj();
    if (sel != null && sel.size() > 0) {
      Object o = sel.iterator().next();
      IProject proj = ((IProject) o);
      GitManipulator gm;
      try {
        gm = new GitManipulator(proj);
        return true;
      } catch (Exception e) {
      }
    }
    return false;
  }
}
